unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZipMstr, StdCtrls, ZipAdapter;

type
  TForm1 = class(TForm)
    ZipMaster1: TZipMaster;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edSpecArgs: TEdit;
    Label2: TLabel;
    edZipFileName: TEdit;
    chkSubFolders: TCheckBox;
    btnCompress: TButton;
    GroupBox2: TGroupBox;
    btnDecompress: TButton;
    Label3: TLabel;
    edExtractDir: TEdit;
    Label4: TLabel;
    edBaseDir: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCompressClick(Sender: TObject);
    procedure btnDecompressClick(Sender: TObject);
  private
    FArchiver: TAbstractArchiver;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FArchiver := TZipAdapter.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FArchiver.Free;
end;

procedure TForm1.btnCompressClick(Sender: TObject);
begin
  DeleteFile(edZipFileName.Text);
  with FArchiver do
  begin
    SpecArgs.Text := edSpecArgs.Text;
    BaseDir := edBaseDir.Text;
    ArchiveName := edZipFileName.Text;
    SubFolders := chkSubFolders.Checked;
    Add;
  end;
  ShowMessage('Done.');
end;

procedure TForm1.btnDecompressClick(Sender: TObject);
begin
  with FArchiver do
  begin
    ArchiveName := edZipFileName.Text;
    SubFolders := chkSubFolders.Checked;
    SpecArgs.Clear; // extract *.*
    ExtractTo(edExtractDir.Text);
  end;
  ShowMessage('Done.');
end;

end.
