unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AbsArchiver, ZipAdapter;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edSpecArgs: TEdit;
    chkSubFolders: TCheckBox;
    btnCompress: TButton;
    Label4: TLabel;
    edBaseDir: TEdit;
    GroupBox2: TGroupBox;
    rdoZip: TRadioButton;
    rdoRar: TRadioButton;
    Label3: TLabel;
    Label2: TLabel;
    edArchiveName: TEdit;
    Label5: TLabel;
    procedure btnCompressClick(Sender: TObject);
    procedure rdoFormatClick(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnCompressClick(Sender: TObject);
var
  arch: TAbstractArchiver;
  s: string;
begin
  // Create concrete archiver class depending on user's choice
  s := 'TZipAdapter';
  if rdoRar.Checked then
    s := 'TRarAdapter';

  arch := ArchiverFactory.CreateInstance(s);

  try
    DeleteFile(edArchiveName.Text);
    with arch do
    begin
      SpecArgs.Text := edSpecArgs.Text;
      BaseDir := edBaseDir.Text;
      ArchiveName := edArchiveName.Text;
      SubFolders := chkSubFolders.Checked;
      Add;
    end;
    arch.Free;
    ShowMessage('Done.');    
  except
    arch.Free;
    raise;
  end;
end;


procedure TForm1.rdoFormatClick(Sender: TObject);
var
  sExtName: string;
begin
  sExtName := '.' + (Sender as TRadioButton).Caption;
  edArchiveName.Text := ChangeFileExt(edArchiveName.Text, sExtName);
end;

end.
